package jp.kirikiri.tvp2.base;

import jp.kirikiri.tjs2.TJSException;
import jp.kirikiri.tjs2.VariantException;
import jp.kirikiri.tvp2.visual.WindowNI;

public class WinUpdateEvent implements Runnable {

	private WindowNI mWindow;

	public WinUpdateEvent( WindowNI window ) {
		mWindow = window;
	}

	public WinUpdateEvent( final WinUpdateEvent ref ) {
		mWindow = ref.mWindow;
	}

	WindowNI getWindow() { return mWindow; }

	void markEmpty() { mWindow = null; }

	boolean isEmpty() { return mWindow == null; }

	public void deliver() throws VariantException, TJSException {
		mWindow.updateContent();
	}

	@Override
	public void run() {
		try {
			mWindow.updateContent();
		} catch (VariantException e) {
		} catch (TJSException e) {
		}
	}

}
